//: C10:Kolo.cpp {O} {-mwcc}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
#include "Bicycle.h"
#include <cassert>
#include <cstddef>
using namespace std;

std::string CastKola::nazvy[NCASTI] = {
  "Rám", "Kolo", "Sedlo", "Přehazovačka",
  "Řídítka", "Rozeta", "Brašna", "Tlumič" };

// implementace StavitelHorskehoKola 
void StavitelHorskehoKola::sestavitRam() {
  produkt->pridatCast(new CastKola(CastKola::RAM));
}
void StavitelHorskehoKola::sestavitKolo() {
  produkt->pridatCast(new CastKola(CastKola::KOLO));
}
void StavitelHorskehoKola::sestavitSedlo() {
  produkt->pridatCast(new CastKola(CastKola::SEDLO));
}
void StavitelHorskehoKola::sestavitPrehazovacku() {
  produkt->pridatCast(
    new CastKola(CastKola::PREHAZOVACKA));
}
void StavitelHorskehoKola::sestavitRiditka() {
  produkt->pridatCast(
    new CastKola(CastKola::RIDITKA));
}
void StavitelHorskehoKola::sestavitRozetu() {
  produkt->pridatCast(new CastKola(CastKola::ROZETA));
}
void StavitelHorskehoKola::sestavitBrasnu() {}
void StavitelHorskehoKola::sestavitTlumic() {
  produkt->pridatCast(new CastKola(CastKola::TLUMIC));
}

// StavitelCestovnihoKola implementation
void StavitelCestovnihoKola::sestavitRam() {
  produkt->pridatCast(new CastKola(CastKola::RAM));
}
void StavitelCestovnihoKola::sestavitKolo() {
  produkt->pridatCast(new CastKola(CastKola::KOLO));
}
void StavitelCestovnihoKola::sestavitSedlo() {
  produkt->pridatCast(new CastKola(CastKola::SEDLO));
}
void StavitelCestovnihoKola::sestavitPrehazovacku() {
  produkt->pridatCast(
    new CastKola(CastKola::PREHAZOVACKA));
}
void StavitelCestovnihoKola::sestavitRiditka() {
  produkt->pridatCast(
    new CastKola(CastKola::RIDITKA));
}
void StavitelCestovnihoKola::sestavitRozetu() {
  produkt->pridatCast(new CastKola(CastKola::ROZETA));
}
void StavitelCestovnihoKola::sestavitBrasnu() {
  produkt->pridatCast(new CastKola(CastKola::BRASNA));
}
void StavitelCestovnihoKola::sestavitTlumic() {}

// Implementace StavitelZavodnihoKola
void StavitelZavodnihoKola::sestavitRam() {
  produkt->pridatCast(new CastKola(CastKola::RAM));
}
void StavitelZavodnihoKola::sestavitKolo() {
  produkt->pridatCast(new CastKola(CastKola::KOLO));
}
void StavitelZavodnihoKola::sestavitSedlo() {
  produkt->pridatCast(new CastKola(CastKola::SEDLO));
}
void StavitelZavodnihoKola::sestavitPrehazovacku() {}
void StavitelZavodnihoKola::sestavitRiditka() {
  produkt->pridatCast(
    new CastKola(CastKola::RIDITKA));
}
void StavitelZavodnihoKola::sestavitRozetu() {
  produkt->pridatCast(new CastKola(CastKola::ROZETA));
}
void StavitelZavodnihoKola::sestavitBrasnu() {}
void StavitelZavodnihoKola::sestavitTlumic() {}

// implamentace MechanikKola
void MechanikKola::sestavit() {
  assert(stavitel);
  stavitel->vytvoritProdukt();
  stavitel->sestavitRam();
  stavitel->sestavitKolo();
  stavitel->sestavitSedlo();
  stavitel->sestavitPrehazovacku();
  stavitel->sestavitRiditka();
  stavitel->sestavitRozetu();
  stavitel->sestavitBrasnu();
  stavitel->sestavitTlumic();
} ///:~
